function Acolyte_LoadOptions()
Acolyte_Options = {
		type = "group",
		args = {
			header = {
				type = "header",
				name = "Acolyte",
				order = 1,
			}, --@note: of header
			locked = {
				order = 2,
				name = "Locked", 
				type = "toggle",
				desc = "Toggle the lock of the buttons.",
				get = function() return AcolyteDB.locked end,
				set = function(v)
					if (AcolyteDB.locked == true) then
						AcolyteDB.locked = false
						Acolyte_MoveButton:Show()
					else
						AcolyteDB.locked = true
						Acolyte_MoveButton:Hide()
					end
				end,
			}, --@note: end locked
			layout = {
				type = "group",
				name = "Layout",
				desc = "Change the look of Acolyte.",
				order = 3,
				args = {
					PopupDirection = {
						order = 1,
						name = "Popup direction", 
						type = "group",
						desc = "Toggle the direction where the Popups drop down, default is left.",
						args = {
							DirectionTOPLEFT = {
								order = 1,
								name = "Top Left", 
								isRadio = true,
								type = "toggle",
								desc = "Top Left",
								get = function() 
										if (AcolyteDB.PopupDirection == "TOPLEFT") then 
											return true 
										else 
											return false 
										end
									end,
								set = function(v)
									AcolyteDB.PopupDirection = "TOPLEFT"
									Acolyte:ReloadLayout()
								end,
							}, --@note: end DirectionTOPLEFT
							DirectionTOPRIGHT = {
								order = 2,
								name = "Top Right", 
								isRadio = true,
								type = "toggle",
								desc = "Top Right",
								get = function() 
										if (AcolyteDB.PopupDirection == "TOPRIGHT") then 
											return true 
										else 
											return false 
										end
									end,
								set = function(v)
									AcolyteDB.PopupDirection = "TOPRIGHT"
									Acolyte:ReloadLayout()
								end,
							}, --@note: end DirectionTOPRIGHT
							DirectionBOTTOMLEFT = {
								order = 3,
								name = "Bottom Left", 
								isRadio = true,
								type = "toggle",
								desc = "Bottom Left",
								get = function() 
										if (AcolyteDB.PopupDirection == "BOTTOMLEFT") then 
											return true 
										else 
											return false 
										end
									end,
								set = function(v)
									AcolyteDB.PopupDirection = "BOTTOMLEFT"
									Acolyte:ReloadLayout()
								end,
							}, --@note: end DirectionBOTTOMLEFT
							DirectionBOTTOMRIGHT = {
								order = 4,
								name = "Bottom Right", 
								isRadio = true,
								type = "toggle",
								desc = "Bottom Right",
								get = function() 
										if (AcolyteDB.PopupDirection == "BOTTOMRIGHT") then 
											return true 
										else 
											return false 
										end
									end,
								set = function(v)
									AcolyteDB.PopupDirection = "BOTTOMRIGHT"
									Acolyte:ReloadLayout()
								end,
							}, --@note: end DirectionBOTTOMLEFT
						}, --@note: end args, PopupDirection
					}, --@note: end PopupDirection
					ButtonsPerZeile = {
						order = 2,
				        type = "range",
				        name = "buttons per line",
				        desc = "Define the number of buttons per line.",
				        min = 1, max = 7, step = 1,
				        set = function(value)
							AcolyteDB.ButtonsPerZeile = value
							Acolyte:ReloadLayout()
				        end,
				        get = function()
				            return AcolyteDB.ButtonsPerZeile
				        end
					}, --@note: end ButtonsPerZeile
					scale = {
						order = 3,
				        type = "range",
				        name = "Scale",
				        desc = "Scales the buttons.",
				        isPercent = true,
				        set = function(value)
							AcolyteDB.Scale = value
							if (AcolyteDB.MinionSummonerEnabled == true) then Acolyte_MinionSummonButton:SetScale(value) end
							if (AcolyteDB.RitualOfSummoningEnabled == true) then Acolyte_RitualOfSummoningButton:SetScale(value) end
							if (AcolyteDB.SpellCasterEnabled == true) then Acolyte_DemonicArmorButton:SetScale(value) end
							if (AcolyteDB.StoneCreatorEnabled == true) then Acolyte_StoneCreatorButton:SetScale(value) end
							if (AcolyteDB.SoulKeeperEnabled == true) then Acolyte_SoulKeeperButton:SetScale(value) end
							if (AcolyteDB.MountSummonerEnabled == true) then Acolyte_MountButton:SetScale(value) end
							if (AcolyteDB.NightFallEnabled == true) then Acolyte_NightFallButton:SetScale(value) end
				        end,
				        get = function()
				            return AcolyteDB.Scale
				        end
					}, --@note: end scale
				}, --@note: end args, layout
			}, --@note: end layout
			modules = {
				type = "group",
				name = "Modules",
				desc = "Options for the different modules.",
				order = 4,
				args = {
					minionsummoner = {
						type = "group",
						name = "Minion summoner",
						desc = "Options of the minion summoner.",
						order = 1,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the minion summoner.",
								get = function() return AcolyteDB.MinionSummonerEnabled end,
								set = function(v)
									if (AcolyteDB.MinionSummonerEnabled == true) then
										AcolyteDB.MinionSummonerEnabled = false
									else
										AcolyteDB.MinionSummonerEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
						}, --@note: end args, minionsummoner
					}, --@note: end minionsummoner
					mountsummoner = {
						type = "group",
						name = "Mount summoner",
						desc = "Options of the mount summoner.",
						order = 2,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the mount summoner.",
								get = function() return AcolyteDB.MountSummonerEnabled end,
								set = function(v)
									if (AcolyteDB.MountSummonerEnabled == true) then
										AcolyteDB.MountSummonerEnabled = false
									else
										AcolyteDB.MountSummonerEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
						}, --@note: end args, mountsummoner
					}, --@note: end mountsummoner
					ritualofsummoning = {
						type = "group",
						name = "Ritual of Summoning",
						desc = "Options of the Ritual of Summoning button.",
						order = 3,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the Ritual of Summoning button.",
								get = function() return AcolyteDB.RitualOfSummoningEnabled end,
								set = function(v)
									if (AcolyteDB.RitualOfSummoningEnabled == true) then
										AcolyteDB.RitualOfSummoningEnabled = false
									else
										AcolyteDB.RitualOfSummoningEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
						}, --@note: end args, RitualOfSummoning
					}, --@note: end RitualOfSummoning
					SpellCaster = {
						type = "group",
						name = "Spell caster",
						desc = "Options of the spell caster button.",
						order = 4,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the spell caster button.",
								get = function() return AcolyteDB.SpellCasterEnabled end,
								set = function(v)
									if (AcolyteDB.SpellCasterEnabled == true) then
										AcolyteDB.SpellCasterEnabled = false
									else
										AcolyteDB.SpellCasterEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
						}, --@note: end args, SpellCaster
					}, --@note: end SpellCaster
					StoneCreator = {
						type = "group",
						name = "Stone creator",
						desc = "Options of the stone creator button.",
						order = 5,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the stone creator button.",
								get = function() return AcolyteDB.StoneCreatorEnabled end,
								set = function(v)
									if (AcolyteDB.StoneCreatorEnabled == true) then
										AcolyteDB.StoneCreatorEnabled = false
									else
										AcolyteDB.StoneCreatorEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
						}, --@note: end args, StoneCreator
					}, --@note: end StoneCreator
					SoulKeeper = {
						type = "group",
						name = "Soulkeeper",
						desc = "Options of the soul keeper button.",
						order = 5,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the soul keeper button.",
								get = function() return AcolyteDB.SoulKeeperEnabled end,
								set = function(v)
									if (AcolyteDB.SoulKeeperEnabled == true) then
										AcolyteDB.SoulKeeperEnabled = false
									else
										AcolyteDB.SoulKeeperEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
							shardNumber = {
								order = 2,
						        type = "range",
						        name = "Number of Shard untill warning",
						        desc = "Define the number of shards when Acolyte print out its low shard warning.",
						        min = 1, max = 30, step = 1,
						        set = function(value)
									AcolyteDB.NumberOfShardsToWarn = value
						        end,
						        get = function()
						            return AcolyteDB.NumberOfShardsToWarn
						        end
							}, --@note: end shardNumber
						}, --@note: end args, SoulKeeper
					}, --@note: end SoulKeeper
					NightFall = {
						type = "group",
						name = "Nightfall",
						desc = "Options of the NightFall button.",
						order = 6,
						args = {
							enabled = {
								order = 1,
								name = "Enabled", 
								type = "toggle",
								desc = "Toggle the NightFall button.",
								get = function() return AcolyteDB.NightFallEnabled end,
								set = function(v)
									if (AcolyteDB.NightFallEnabled == true) then
										AcolyteDB.NightFallEnabled = false
									else
										AcolyteDB.NightFallEnabled = true
									end
									Acolyte:ReloadLayout()
								end,
							}, --@note: end enabled
							askFlashFrame = {
								order = 2,
								name = AcoLoc.askFlashFrame,
								type = "toggle",
								desc = AcoLoc.askFlashFrame,
								get = function() return AcolyteDB.flashFrame end,
								set = function(v)
										if (AcolyteDB.flashFrame == true) then
											AcolyteDB.flashFrame = false
										else
											AcolyteDB.flashFrame = true
										end
									  end									
							}, --@note: end askFlashFrame
							askShowIcon = {
								order = 3,
								name = AcoLoc.askShowIcon,
								type = "toggle",
								desc = AcoLoc.askShowIcon,
								get = function() return AcolyteDB.showIcon end,
								set = function(v)
										if (AcolyteDB.showIcon == true) then
											AcolyteDB.showIcon = false
										else
											AcolyteDB.showIcon = true
										end
									  end									  
							}, --@note: end askShowIcon
							askChatWarning = {
								order = 4,
								name = AcoLoc.askChatWarning,
								type = "toggle",
								desc = AcoLoc.askChatWarning,
								get = function() return AcolyteDB.ChatWarning end,
								set = function(v)
										if (AcolyteDB.ChatWarning == true) then
											AcolyteDB.ChatWarning = false
										else
											AcolyteDB.ChatWarning = true
										end
									  end									  
							}, --@note: end askShowIcon
						}, --@note: end args, NightFall
					}, --@note: end NightFall
				}, --@note: end args, modules
			}, --@note: end modules
		}, --@note: of args
	} --@note: of Acolyte_Options		
end --@note: of function