function Acolyte:CreateSpellCaster()
	--
	--@desc: creating Spell caster Button
	--
	if (AcolyteDB.SpellCasterEnabled == true) then
			Acolyte_DemonicArmorButton = CreateFrame("Button", "Acolyte_DemonicArmorButton", UIParent, "SecureActionButtonTemplate")
		Acolyte_DemonicArmorButton:SetFrameStrata("HIGH")
		Acolyte_DemonicArmorButton:SetWidth(32)
		Acolyte_DemonicArmorButton:SetHeight(32)
		Acolyte_DemonicArmorButton:SetMovable(true)
		Acolyte_DemonicArmorButton:EnableMouse(true)
		Acolyte_DemonicArmorButton:RegisterForDrag("LeftButton")
		Acolyte_DemonicArmorButton:RegisterForClicks("RightButtonDown", "LeftButtonDown")
		Acolyte_DemonicArmorButton:SetScale(AcolyteDB.Scale)
			Acolyte_DemonicArmorButtonTexture = Acolyte_DemonicArmorButton:CreateTexture(nil,"HIGH")
		Acolyte_DemonicArmorButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\DemonicArmorButton")
		Acolyte_DemonicArmorButtonTexture:SetAllPoints(Acolyte_DemonicArmorButton)
		Acolyte_DemonicArmorButton.texture = Acolyte_DemonicArmorButtonTexture
		Acolyte_DemonicArmorButton:SetPoint("CENTER",Acolyte:getParent(ButtonsCreated, lastParent),"CENTER",LayoutPosition[ButtonsCreated].x,LayoutPosition[ButtonsCreated].y)
		Acolyte_DemonicArmorButton:SetScript("PostClick", function() Acolyte:DemonicArmorDropDown() end)
		Acolyte_DemonicArmorButton:Show()
		
		lastParent = Acolyte_DemonicArmorButton
		ButtonsCreated = ButtonsCreated + 1
	end
	
	Acolyte:CreateStoneCreator()
end

function Acolyte:DemonicArmorDropDown()

	if (not SpellCasterCreated == true) then
	
		SpellCasterCreated = true

		Acolyte:HideAllPopups()
		if (not UnitAffectingCombat("player")) then

		--
		--@desc: creating the Armor Button
		--
		DemonArmorButton = CreateFrame("Button", "DemonArmorButton", UIParent, "SecureActionButtonTemplate")
		DemonArmorButton:SetFrameStrata("HIGH")
		DemonArmorButton:SetWidth(32)
		DemonArmorButton:SetHeight(32)
		DemonArmorButtonTexture = DemonArmorButton:CreateTexture(nil,"HIGH")
		DemonArmorButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\"..Acolyte:getArmorImage())
		DemonArmorButtonTexture:SetAllPoints(DemonArmorButton)
		DemonArmorButton.texture = DemonArmorButtonTexture
		DemonArmorButton:SetPoint("CENTER",Acolyte_DemonicArmorButton,PopupLayout.DemonArmorButton.x,PopupLayout.DemonArmorButton.y)
		DemonArmorButtonFontString = DemonArmorButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		DemonArmorButtonFontString:SetJustifyH("LEFT")
		DemonArmorButtonFontString:SetPoint("TOPLEFT", DemonArmorButton, "TOPLEFT", 30, -8)
		DemonArmorButtonFontString:SetText(Acolyte:getArmorType())
		if (not AcolyteDB.SpellDB.DemonSkinAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		DemonArmorButtonFontString:SetTextColor(R,G,B)
		DemonArmorButton:Show()
		
		DemonArmorOverlay = CreateFrame("Button","DemonArmorOverlay",UIParent, "SecureActionButtonTemplate")
		DemonArmorOverlay:RegisterForClicks("LeftButtonDown")
		DemonArmorOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", Acolyte:getArmorType())
		end)
		DemonArmorOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		DemonArmorOverlay:SetScript("OnEnter", function(self)
		        DemonArmorOverlay:SetAlpha(0.5)
		end)
		DemonArmorOverlay:SetScript("OnLeave", function(self)
		        DemonArmorOverlay:SetAlpha(0)
		end)
		DemonArmorOverlay:SetFrameStrata("DIALOG")
		DemonArmorOverlay:SetWidth(190)
		DemonArmorOverlay:SetHeight(30)
		DemonArmorOverlay:SetPoint("TOPLEFT", DemonArmorButton, "TOPLEFT", -3, -2)
		DemonArmorOverlay:SetAlpha(0)
		DemonArmorOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		DemonArmorOverlay:Show()
		
		
		--
		--@desc: creating the Sense Demons Button
		--
		SenseDemonsButton = CreateFrame("Button", "SenseDemonsButton", UIParent, "SecureActionButtonTemplate")
		SenseDemonsButton:SetFrameStrata("HIGH")
		SenseDemonsButton:SetWidth(32)
		SenseDemonsButton:SetHeight(32)
		SenseDemonsButtonTexture = SenseDemonsButton:CreateTexture(nil,"HIGH")
		SenseDemonsButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\SenseDemons")
		SenseDemonsButtonTexture:SetAllPoints(SenseDemonsButton)
		SenseDemonsButton.texture = SenseDemonsButtonTexture
		SenseDemonsButton:SetPoint("CENTER",DemonArmorButton,0,-28)
		SenseDemonsButtonFontString = SenseDemonsButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		SenseDemonsButtonFontString:SetJustifyH("LEFT")
		SenseDemonsButtonFontString:SetPoint("TOPLEFT", SenseDemonsButton, "TOPLEFT", 30, -8)
		SenseDemonsButtonFontString:SetText(AcoLoc.SenseDemons)
		if (not AcolyteDB.SpellDB.SenseDemonsAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		SenseDemonsButtonFontString:SetTextColor(R,G,B)
		SenseDemonsButton:Show()
		
		SenseDemonsOverlay = CreateFrame("Button","SenseDemonsOverlay",UIParent, "SecureActionButtonTemplate")
		SenseDemonsOverlay:RegisterForClicks("LeftButtonDown")
		SenseDemonsOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", AcoLoc.SenseDemons)
		end)
		SenseDemonsOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		SenseDemonsOverlay:SetScript("OnEnter", function(self)
		        SenseDemonsOverlay:SetAlpha(0.5)
		end)
		SenseDemonsOverlay:SetScript("OnLeave", function(self)
		        SenseDemonsOverlay:SetAlpha(0)
		end)
		
		SenseDemonsOverlay:SetFrameStrata("DIALOG")
		SenseDemonsOverlay:SetWidth(190)
		SenseDemonsOverlay:SetHeight(30)
		SenseDemonsOverlay:SetPoint("TOPLEFT", SenseDemonsButton, "TOPLEFT", -3, -2)
		SenseDemonsOverlay:SetAlpha(0)
		SenseDemonsOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		SenseDemonsOverlay:Show()
		
		
		--
		--@desc: creating the Unending Breath Button
		--
		UnendingBreathButton = CreateFrame("Button", "UnendingBreathButton", UIParent, "SecureActionButtonTemplate")
		UnendingBreathButton:SetFrameStrata("HIGH")
		UnendingBreathButton:SetWidth(32)
		UnendingBreathButton:SetHeight(32)
		UnendingBreathButtonTexture = UnendingBreathButton:CreateTexture(nil,"HIGH")
		UnendingBreathButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\UnendingBreath")
		UnendingBreathButtonTexture:SetAllPoints(UnendingBreathButton)
		UnendingBreathButton.texture = UnendingBreathButtonTexture
		UnendingBreathButton:SetPoint("CENTER",SenseDemonsButton,0,-28)
		UnendingBreathButtonFontString = UnendingBreathButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		UnendingBreathButtonFontString:SetJustifyH("LEFT")
		UnendingBreathButtonFontString:SetPoint("TOPLEFT", UnendingBreathButton, "TOPLEFT", 30, -8)
		UnendingBreathButtonFontString:SetText(AcoLoc.UnendingBreath)
		if (not AcolyteDB.SpellDB.UnendingBreathAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		UnendingBreathButtonFontString:SetTextColor(R,G,B)
		UnendingBreathButton:Show()
		
		UnendingBreathOverlay = CreateFrame("Button","UnendingBreathOverlay",UIParent, "SecureActionButtonTemplate")
		UnendingBreathOverlay:RegisterForClicks("LeftButtonDown")
		UnendingBreathOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", AcoLoc.UnendingBreath)
		end)
		UnendingBreathOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		UnendingBreathOverlay:SetScript("OnEnter", function(self)
		        UnendingBreathOverlay:SetAlpha(0.5)
		end)
		UnendingBreathOverlay:SetScript("OnLeave", function(self)
		        UnendingBreathOverlay:SetAlpha(0)
		end)
		
		UnendingBreathOverlay:SetFrameStrata("DIALOG")
		UnendingBreathOverlay:SetWidth(190)
		UnendingBreathOverlay:SetHeight(30)
		UnendingBreathOverlay:SetPoint("TOPLEFT", UnendingBreathButton, "TOPLEFT", -3, -2)
		UnendingBreathOverlay:SetAlpha(0)
		UnendingBreathOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		UnendingBreathOverlay:Show()
		

		--
		--@desc: creating the Felhunter Button
		--
		DetectInvisibilityButton = CreateFrame("Button", "DetectInvisibilityButton", UIParent, "SecureActionButtonTemplate")
		DetectInvisibilityButton:SetFrameStrata("HIGH")
		DetectInvisibilityButton:SetWidth(32)
		DetectInvisibilityButton:SetHeight(32)
		DetectInvisibilityButtonTexture = DetectInvisibilityButton:CreateTexture(nil,"HIGH")
		DetectInvisibilityButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\DetectInvisibility")
		DetectInvisibilityButtonTexture:SetAllPoints(DetectInvisibilityButton)
		DetectInvisibilityButton.texture = DetectInvisibilityButtonTexture
		DetectInvisibilityButton:SetPoint("CENTER",UnendingBreathButton,0,-28)
		DetectInvisibilityButtonFontString = DetectInvisibilityButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		DetectInvisibilityButtonFontString:SetJustifyH("LEFT")
		DetectInvisibilityButtonFontString:SetPoint("TOPLEFT", DetectInvisibilityButton, "TOPLEFT", 30, -8)
		DetectInvisibilityButtonFontString:SetText(AcoLoc.DetectInvisibility)
		if (not AcolyteDB.SpellDB.DetectInvisibilityAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		DetectInvisibilityButtonFontString:SetTextColor(R,G,B)
		DetectInvisibilityButton:Show()

		DetectInvisibilityOverlay = CreateFrame("Button","DetectInvisibilityOverlay",UIParent, "SecureActionButtonTemplate")
		DetectInvisibilityOverlay:RegisterForClicks("LeftButtonDown")
		DetectInvisibilityOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", AcoLoc.DetectInvisibility)
		end)
		DetectInvisibilityOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		DetectInvisibilityOverlay:SetScript("OnEnter", function(self)
		        DetectInvisibilityOverlay:SetAlpha(0.5)
		end)
		DetectInvisibilityOverlay:SetScript("OnLeave", function(self)
		        DetectInvisibilityOverlay:SetAlpha(0)
		end)
		
		DetectInvisibilityOverlay:SetFrameStrata("DIALOG")
		DetectInvisibilityOverlay:SetWidth(190)
		DetectInvisibilityOverlay:SetHeight(30)
		DetectInvisibilityOverlay:SetPoint("TOPLEFT", DetectInvisibilityButton, "TOPLEFT", -3, -2)
		DetectInvisibilityOverlay:SetAlpha(0)
		DetectInvisibilityOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		DetectInvisibilityOverlay:Show()
		
		
		--
		--@desc: creating the Background
		--
		SpellCasterBackground = CreateFrame("Button","SpellCasterBackground",UIParent)
		SpellCasterBackground:SetFrameStrata("HIGH")
		SpellCasterBackground:SetWidth(195)
		SpellCasterBackground:SetHeight(120)

		SpellCasterBackground:SetPoint("TOPLEFT", DemonArmorButton, "TOPLEFT", -5, 2)
		SpellCasterBackground:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		SpellCasterBackground:SetScript("PostClick", function(self)
			Acolyte:HideAllPopups()
		end)
		SpellCasterBackground:Show()
		end
	else
		if (not UnitAffectingCombat("player")) then
			DemonArmorButton:Show()
			SenseDemonsButton:Show()
			UnendingBreathButton:Show()
			DetectInvisibilityButton:Show()
			SpellCasterBackground:Show()
			DemonArmorOverlay:Show()
			SenseDemonsOverlay:Show()
			UnendingBreathOverlay:Show()
			DetectInvisibilityOverlay:Show()
		end
	end
end

--
--@desc: hide all frames
--
function Acolyte:HideShieldSensePopup()
	if (SpellCasterBackground) then
		DemonArmorButton:Hide()
		SenseDemonsButton:Hide()
		UnendingBreathButton:Hide()
		DetectInvisibilityButton:Hide()
		SpellCasterBackground:Hide()
		DemonArmorOverlay:Hide()
		SenseDemonsOverlay:Hide()
		UnendingBreathOverlay:Hide()
		DetectInvisibilityOverlay:Hide()
	end 
end 

--
--@desc: function to determinate wich armor type the player got
--
function Acolyte:getArmorType() 
	if (AcolyteDB.SpellDB.FelArmorAvailable == true) then
		return AcoLoc.FelArmor
	elseif (AcolyteDB.SpellDB.DemonArmorAvailable == true) then
		return AcoLoc.DemonArmor
	elseif (AcolyteDB.SpellDB.DemonSkinAvailable == true) then
		return AcoLoc.DemonSkin
	end
end 

--
--@desc: function to determinate wich Image on the armor button will be displayed
--
function Acolyte:getArmorImage()
	if Acolyte:PlayerHasSpell(AcoLoc.FelArmor) then
		return "FelArmor"
	elseif Acolyte:PlayerHasSpell(AcoLoc.DemonSkin) then -- Icons for Demon Armor and Skin are the same
		return "DemonArmor"
	end
end 