function Acolyte:CreateStoneCreator()
	-- Stone Creator Button
	if (AcolyteDB.StoneCreatorEnabled == true) then
			Acolyte_StoneCreatorButton = CreateFrame("Button", "Acolyte_StoneCreatorButton", UIParent, "SecureActionButtonTemplate")
		Acolyte_StoneCreatorButton:SetFrameStrata("HIGH")
		Acolyte_StoneCreatorButton:SetWidth(32)
		Acolyte_StoneCreatorButton:SetHeight(32)
		Acolyte_StoneCreatorButton:SetMovable(true)
		Acolyte_StoneCreatorButton:EnableMouse(true)
		Acolyte_StoneCreatorButton:RegisterForDrag("LeftButton")
		Acolyte_StoneCreatorButton:RegisterForClicks("RightButtonDown", "LeftButtonDown")
		Acolyte_StoneCreatorButton:SetScale(AcolyteDB.Scale)
			Acolyte_StoneCreatorButtonTexture = Acolyte_StoneCreatorButton:CreateTexture(nil,"HIGH")
		Acolyte_StoneCreatorButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\StoneCreatorButton")
		Acolyte_StoneCreatorButtonTexture:SetAllPoints(Acolyte_StoneCreatorButton)
		Acolyte_StoneCreatorButton.texture = Acolyte_StoneCreatorButtonTexture
		Acolyte_StoneCreatorButton:SetPoint("CENTER",Acolyte:getParent(ButtonsCreated, lastParent),"CENTER",LayoutPosition[ButtonsCreated].x,LayoutPosition[ButtonsCreated].y)
		Acolyte_StoneCreatorButton:SetScript("PostClick", function() Acolyte:StoneCreatorDropDown() end)
		Acolyte_StoneCreatorButton:Show()

		lastParent = Acolyte_StoneCreatorButton
		ButtonsCreated = ButtonsCreated + 1
	end
	
	Acolyte:CreateSoulKeeper()
end

--@desc: the Dropdown for the stones
function Acolyte:StoneCreatorDropDown()

	if (not StoneCreatorCreated == true) then
	
		StoneCreatorCreated = true

		Acolyte:HideAllPopups()
		if (not UnitAffectingCombat("player")) then
		
		--
		--@desc: creating the Healthstone Button
		--
		HealthStoneButton = CreateFrame("Button", "HealthStoneButton", UIParent, "SecureActionButtonTemplate")
		HealthStoneButton:SetFrameStrata("HIGH")
		HealthStoneButton:SetWidth(32)
		HealthStoneButton:SetHeight(32)
		HealthStoneButtonTexture = HealthStoneButton:CreateTexture(nil,"HIGH")
		HealthStoneButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\HealthStone")
		HealthStoneButtonTexture:SetAllPoints(HealthStoneButton)
		HealthStoneButton.texture = HealthStoneButtonTexture
		HealthStoneButton:SetPoint("CENTER",Acolyte_StoneCreatorButton,PopupLayout.HealthStoneButton.x,PopupLayout.HealthStoneButton.y)
		HealthStoneButtonFontString = HealthStoneButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		HealthStoneButtonFontString:SetJustifyH("LEFT")
		HealthStoneButtonFontString:SetPoint("TOPLEFT", HealthStoneButton, "TOPLEFT", 30, -8)
		HealthStoneButtonFontString:SetText(Acolyte:ChooseStoneLoc(AcoLoc.HealthStone,true))
		if (not AcolyteDB.SpellDB.HealthStoneAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		HealthStoneButtonFontString:SetTextColor(R,G,B)
		HealthStoneButton:Show()

		HealthStoneButtonOverlay = CreateFrame("Button","HealthStoneButtonOverlay",UIParent, "SecureActionButtonTemplate")
		HealthStoneButtonOverlay:RegisterForClicks("LeftButtonDown")
		HealthStoneButtonOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", Acolyte:ChooseStoneLoc(AcoLoc.HealthStone))
		end)
		HealthStoneButtonOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		HealthStoneButtonOverlay:SetScript("OnEnter", function(self)
		        HealthStoneButtonOverlay:SetAlpha(0.5)
		end)
		HealthStoneButtonOverlay:SetScript("OnLeave", function(self)
		        HealthStoneButtonOverlay:SetAlpha(0)
		end)
		
		HealthStoneButtonOverlay:SetFrameStrata("DIALOG")
		HealthStoneButtonOverlay:SetWidth(200)
		HealthStoneButtonOverlay:SetHeight(30)
		HealthStoneButtonOverlay:SetPoint("TOPLEFT", HealthStoneButton, "TOPLEFT", -3, -2)
		HealthStoneButtonOverlay:SetAlpha(0)
		HealthStoneButtonOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		HealthStoneButtonOverlay:Show()		
		
		
		--
		--@desc: creating the Soulstone Button
		--
		SoulStoneButton = CreateFrame("Button", "SoulStoneButton", UIParent, "SecureActionButtonTemplate")
		SoulStoneButton:SetFrameStrata("HIGH")
		SoulStoneButton:SetWidth(32)
		SoulStoneButton:SetHeight(32)
		SoulStoneButtonTexture = SoulStoneButton:CreateTexture(nil,"HIGH")
		SoulStoneButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\SoulStone")
		SoulStoneButtonTexture:SetAllPoints(SoulStoneButton)
		SoulStoneButton.texture = SoulStoneButtonTexture
		SoulStoneButton:SetPoint("CENTER",HealthStoneButton,0,-28)
		SoulStoneButtonFontString = SoulStoneButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		SoulStoneButtonFontString:SetJustifyH("LEFT")
		SoulStoneButtonFontString:SetPoint("TOPLEFT", SoulStoneButton, "TOPLEFT", 30, -8)
		SoulStoneButtonFontString:SetText(Acolyte:ChooseStoneLoc(AcoLoc.SoulStone,true))
		if (not AcolyteDB.SpellDB.SoulStoneAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		SoulStoneButtonFontString:SetTextColor(R,G,B)
		SoulStoneButton:Show()

		SoulStoneButtonOverlay = CreateFrame("Button","SoulStoneButtonOverlay",UIParent, "SecureActionButtonTemplate")
		SoulStoneButtonOverlay:RegisterForClicks("LeftButtonDown")
		SoulStoneButtonOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", Acolyte:ChooseStoneLoc(AcoLoc.SoulStone))
		end)
		SoulStoneButtonOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		SoulStoneButtonOverlay:SetScript("OnEnter", function(self)
		        SoulStoneButtonOverlay:SetAlpha(0.5)
		end)
		SoulStoneButtonOverlay:SetScript("OnLeave", function(self)
		        SoulStoneButtonOverlay:SetAlpha(0)
		end)
		
		SoulStoneButtonOverlay:SetFrameStrata("DIALOG")
		SoulStoneButtonOverlay:SetWidth(200)
		SoulStoneButtonOverlay:SetHeight(30)
		SoulStoneButtonOverlay:SetPoint("TOPLEFT", SoulStoneButton, "TOPLEFT", -3, -2)
		SoulStoneButtonOverlay:SetAlpha(0)
		SoulStoneButtonOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		SoulStoneButtonOverlay:Show()
		
		
		--
		--@desc: creating the Spellstone Button
		--
		SpellStoneButton = CreateFrame("Button", "SpellStoneButton", UIParent, "SecureActionButtonTemplate")
		SpellStoneButton:SetFrameStrata("HIGH")
		SpellStoneButton:SetWidth(32)
		SpellStoneButton:SetHeight(32)
		SpellStoneButtonTexture = SpellStoneButton:CreateTexture(nil,"HIGH")
		SpellStoneButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\SpellStone")
		SpellStoneButtonTexture:SetAllPoints(SpellStoneButton)
		SpellStoneButton.texture = SpellStoneButtonTexture
		SpellStoneButton:SetPoint("CENTER",SoulStoneButton,0,-28)
		SpellStoneButtonFontString = SpellStoneButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		SpellStoneButtonFontString:SetJustifyH("LEFT")
		SpellStoneButtonFontString:SetPoint("TOPLEFT", SpellStoneButton, "TOPLEFT", 30, -8)
		SpellStoneButtonFontString:SetText(Acolyte:ChooseStoneLoc(AcoLoc.SpellStone,true))
		if (not AcolyteDB.SpellDB.SpellStoneAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		SpellStoneButtonFontString:SetTextColor(R,G,B)
		SpellStoneButton:Show()

		SpellStoneButtonOverlay = CreateFrame("Button","SpellStoneButtonOverlay",UIParent, "SecureActionButtonTemplate")
		SpellStoneButtonOverlay:RegisterForClicks("LeftButtonDown")
		SpellStoneButtonOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", Acolyte:ChooseStoneLoc(AcoLoc.SpellStone))
		end)
		SpellStoneButtonOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		SpellStoneButtonOverlay:SetScript("OnEnter", function(self)
		        SpellStoneButtonOverlay:SetAlpha(0.5)
		end)
		SpellStoneButtonOverlay:SetScript("OnLeave", function(self)
		        SpellStoneButtonOverlay:SetAlpha(0)
		end)
		
		SpellStoneButtonOverlay:SetFrameStrata("DIALOG")
		SpellStoneButtonOverlay:SetWidth(200)
		SpellStoneButtonOverlay:SetHeight(30)
		SpellStoneButtonOverlay:SetPoint("TOPLEFT", SpellStoneButton, "TOPLEFT", -3, -2)
		SpellStoneButtonOverlay:SetAlpha(0)
		SpellStoneButtonOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		SpellStoneButtonOverlay:Show()

		
		--
		--@desc: creating the Firestone Button
		--
		FireStoneButton = CreateFrame("Button", "FireStoneButton", UIParent, "SecureActionButtonTemplate")
		FireStoneButton:SetFrameStrata("HIGH")
		FireStoneButton:SetWidth(32)
		FireStoneButton:SetHeight(32)
		FireStoneButtonTexture = FireStoneButton:CreateTexture(nil,"HIGH")
		FireStoneButtonTexture:SetTexture("Interface\\AddOns\\Acolyte\\Images\\FireStone")
		FireStoneButtonTexture:SetAllPoints(FireStoneButton)
		FireStoneButton.texture = FireStoneButtonTexture
		FireStoneButton:SetPoint("CENTER",SpellStoneButton,0,-28)
		FireStoneButtonFontString = FireStoneButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		FireStoneButtonFontString:SetJustifyH("LEFT")
		FireStoneButtonFontString:SetPoint("TOPLEFT", FireStoneButton, "TOPLEFT", 30, -8)
		FireStoneButtonFontString:SetText(Acolyte:ChooseStoneLoc(AcoLoc.FireStone,true))
		if (not AcolyteDB.SpellDB.FireStoneAvailable == true) then R, G, B = 1, 0, 0 else R, G, B = 1, 1, 1 end
		FireStoneButtonFontString:SetTextColor(R,G,B)
		FireStoneButton:Show()

		FireStoneButtonOverlay = CreateFrame("Button","FireStoneButtonOverlay",UIParent, "SecureActionButtonTemplate")
		FireStoneButtonOverlay:RegisterForClicks("LeftButtonDown")
		FireStoneButtonOverlay:SetScript("PreClick", function(self)
		        self:SetAttribute("type1", "spell")
		        self:SetAttribute("spell1", Acolyte:ChooseStoneLoc(AcoLoc.FireStone))
		end)
		FireStoneButtonOverlay:SetScript("PostClick", function(self)
				Acolyte:HideAllPopups()
		end)
		FireStoneButtonOverlay:SetScript("OnEnter", function(self)
		        FireStoneButtonOverlay:SetAlpha(0.5)
		end)
		FireStoneButtonOverlay:SetScript("OnLeave", function(self)
		        FireStoneButtonOverlay:SetAlpha(0)
		end)
		
		FireStoneButtonOverlay:SetFrameStrata("DIALOG")
		FireStoneButtonOverlay:SetWidth(200)
		FireStoneButtonOverlay:SetHeight(30)
		FireStoneButtonOverlay:SetPoint("TOPLEFT", FireStoneButton, "TOPLEFT", -3, -2)
		FireStoneButtonOverlay:SetAlpha(0)
		FireStoneButtonOverlay:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		FireStoneButtonOverlay:Show()
		
		
		--
		--@desc: creating the Background
		--
		StonesBackground = CreateFrame("Button","StonesBackground",UIParent)
		StonesBackground:SetFrameStrata("HIGH")
		StonesBackground:SetWidth(205)
		StonesBackground:SetHeight(120)

		StonesBackground:SetPoint("TOPLEFT", HealthStoneButton, "TOPLEFT", -5, 2)
		StonesBackground:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",edgeSize = 15 , insets = { left = 2, right = 2, top = 2, bottom = 2}})
		StonesBackground:SetScript("PostClick", function(self)
			Acolyte:HideAllPopups()
		end)
		StonesBackground:Show()
		end
	else
		HealthStoneButton:Show()
		SoulStoneButton:Show()
		SpellStoneButton:Show()
		FireStoneButton:Show()
		StonesBackground:Show()
		HealthStoneButtonOverlay:Show()
		SoulStoneButtonOverlay:Show()
		SpellStoneButtonOverlay:Show()
		FireStoneButtonOverlay:Show()	
	end
end

--@desc: hide all frames
function Acolyte:HideStonesPopup()
	if (StonesBackground) then
		HealthStoneButton:Hide()
		SoulStoneButton:Hide()
		SpellStoneButton:Hide()
		FireStoneButton:Hide()
		StonesBackground:Hide()
		HealthStoneButtonOverlay:Hide()
		SoulStoneButtonOverlay:Hide()
		SpellStoneButtonOverlay:Hide()
		FireStoneButtonOverlay:Hide()
	end 
end 

--@desc: choose the localized strings
function Acolyte:ChooseStoneLoc(stone,forPopup)
	if forPopup == true then
		if (GetLocale() == "deDE") then 
			StoneToCast = stone..AcoLoc.create
		else
			StoneToCast = AcoLoc.create..stone
		end	
	else
		if (GetLocale() == "deDE") then 
			StoneToCast = stone..AcoLoc.create..'()' 
		else
			StoneToCast = AcoLoc.create..stone..'()'
		end
	end
	return StoneToCast
end 
